using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using WJ.V2.Reader;
using WJ.MPR.Util;

namespace WindowsApplication3
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button readtag;
		private System.Windows.Forms.Button connect;
		private System.Windows.Forms.Button networkstatus;
		private System.Windows.Forms.Button clear;
		private System.Windows.Forms.Button quit;
		private System.Windows.Forms.Label lblQnum;
		private System.Windows.Forms.TextBox inputQnum;
		private System.Windows.Forms.TextBox inputMaxTagCount;
		private System.Windows.Forms.Label lblMaxTagCount;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		bool connected = false;
		V2Reader rdr1 = new V2Reader();
		Gen2InventorySettingsStruct Gen2InventorySettings = new Gen2InventorySettingsStruct(4, 2);
		private System.Windows.Forms.CheckBox inputLoopRead;
		private System.Windows.Forms.TextBox inputLoopDelay;
		private System.Windows.Forms.Label lblLoopDelay;
		private System.Windows.Forms.Button btnDisconnect;
		Inventory readerInv = new Inventory();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.readtag = new System.Windows.Forms.Button();
			this.networkstatus = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.clear = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.connect = new System.Windows.Forms.Button();
			this.quit = new System.Windows.Forms.Button();
			this.lblQnum = new System.Windows.Forms.Label();
			this.inputQnum = new System.Windows.Forms.TextBox();
			this.inputMaxTagCount = new System.Windows.Forms.TextBox();
			this.lblMaxTagCount = new System.Windows.Forms.Label();
			this.inputLoopRead = new System.Windows.Forms.CheckBox();
			this.inputLoopDelay = new System.Windows.Forms.TextBox();
			this.lblLoopDelay = new System.Windows.Forms.Label();
			this.btnDisconnect = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// readtag
			// 
			this.readtag.Enabled = false;
			this.readtag.Location = new System.Drawing.Point(24, 80);
			this.readtag.Name = "readtag";
			this.readtag.Size = new System.Drawing.Size(104, 32);
			this.readtag.TabIndex = 0;
			this.readtag.Text = "Read Tags";
			this.readtag.Click += new System.EventHandler(this.button1_Click);
			// 
			// networkstatus
			// 
			this.networkstatus.Enabled = false;
			this.networkstatus.Location = new System.Drawing.Point(24, 184);
			this.networkstatus.Name = "networkstatus";
			this.networkstatus.Size = new System.Drawing.Size(104, 32);
			this.networkstatus.TabIndex = 1;
			this.networkstatus.Text = "Report Network Status";
			this.networkstatus.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.AcceptsReturn = true;
			this.textBox1.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.textBox1.Location = new System.Drawing.Point(72, 16);
			this.textBox1.MaxLength = 4;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(56, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.WordWrap = false;
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "File";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Quit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(136, 16);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(304, 316);
			this.listBox1.TabIndex = 3;
			this.listBox1.SelectedIndexChanged += new System.EventHandler(this.listBox1_SelectedIndexChanged);
			// 
			// clear
			// 
			this.clear.Location = new System.Drawing.Point(456, 72);
			this.clear.Name = "clear";
			this.clear.Size = new System.Drawing.Size(104, 32);
			this.clear.TabIndex = 5;
			this.clear.Text = "Clear";
			this.clear.Click += new System.EventHandler(this.button3_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 24);
			this.label2.TabIndex = 6;
			this.label2.Text = "COM PORT:";
			this.label2.Click += new System.EventHandler(this.label2_Click);
			// 
			// connect
			// 
			this.connect.Enabled = false;
			this.connect.Location = new System.Drawing.Point(24, 40);
			this.connect.Name = "connect";
			this.connect.Size = new System.Drawing.Size(104, 32);
			this.connect.TabIndex = 7;
			this.connect.Text = "Connect";
			this.connect.Click += new System.EventHandler(this.button4_Click);
			// 
			// quit
			// 
			this.quit.Location = new System.Drawing.Point(456, 120);
			this.quit.Name = "quit";
			this.quit.Size = new System.Drawing.Size(104, 32);
			this.quit.TabIndex = 8;
			this.quit.Text = "Quit";
			this.quit.Click += new System.EventHandler(this.button1_Click_1);
			// 
			// lblQnum
			// 
			this.lblQnum.Location = new System.Drawing.Point(144, 344);
			this.lblQnum.Name = "lblQnum";
			this.lblQnum.Size = new System.Drawing.Size(16, 24);
			this.lblQnum.TabIndex = 9;
			this.lblQnum.Text = "Q";
			this.lblQnum.Visible = false;
			// 
			// inputQnum
			// 
			this.inputQnum.Location = new System.Drawing.Point(160, 344);
			this.inputQnum.MaxLength = 3;
			this.inputQnum.Name = "inputQnum";
			this.inputQnum.Size = new System.Drawing.Size(32, 20);
			this.inputQnum.TabIndex = 10;
			this.inputQnum.Text = "";
			this.inputQnum.Visible = false;
			this.inputQnum.TextChanged += new System.EventHandler(this.inputQnum_TextChanged);
			// 
			// inputMaxTagCount
			// 
			this.inputMaxTagCount.Location = new System.Drawing.Point(296, 344);
			this.inputMaxTagCount.Name = "inputMaxTagCount";
			this.inputMaxTagCount.Size = new System.Drawing.Size(32, 20);
			this.inputMaxTagCount.TabIndex = 11;
			this.inputMaxTagCount.Text = "";
			this.inputMaxTagCount.Visible = false;
			this.inputMaxTagCount.TextChanged += new System.EventHandler(this.inputMaxTagCount_TextChanged);
			// 
			// lblMaxTagCount
			// 
			this.lblMaxTagCount.Location = new System.Drawing.Point(208, 344);
			this.lblMaxTagCount.Name = "lblMaxTagCount";
			this.lblMaxTagCount.Size = new System.Drawing.Size(88, 24);
			this.lblMaxTagCount.TabIndex = 12;
			this.lblMaxTagCount.Text = "Max Tag Count";
			this.lblMaxTagCount.Visible = false;
			// 
			// inputLoopRead
			// 
			this.inputLoopRead.Location = new System.Drawing.Point(48, 120);
			this.inputLoopRead.Name = "inputLoopRead";
			this.inputLoopRead.Size = new System.Drawing.Size(80, 16);
			this.inputLoopRead.TabIndex = 13;
			this.inputLoopRead.Text = "Loop Read";
			this.inputLoopRead.CheckedChanged += new System.EventHandler(this.inputLoopRead_CheckedChanged);
			// 
			// inputLoopDelay
			// 
			this.inputLoopDelay.Location = new System.Drawing.Point(72, 152);
			this.inputLoopDelay.Name = "inputLoopDelay";
			this.inputLoopDelay.Size = new System.Drawing.Size(48, 20);
			this.inputLoopDelay.TabIndex = 14;
			this.inputLoopDelay.Text = "";
			this.inputLoopDelay.TextChanged += new System.EventHandler(this.inputLoopDelay_TextChanged);
			// 
			// lblLoopDelay
			// 
			this.lblLoopDelay.Location = new System.Drawing.Point(8, 144);
			this.lblLoopDelay.Name = "lblLoopDelay";
			this.lblLoopDelay.Size = new System.Drawing.Size(64, 32);
			this.lblLoopDelay.TabIndex = 15;
			this.lblLoopDelay.Text = "Loop Delay (ms)";
			this.lblLoopDelay.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// btnDisconnect
			// 
			this.btnDisconnect.Enabled = false;
			this.btnDisconnect.Location = new System.Drawing.Point(456, 24);
			this.btnDisconnect.Name = "btnDisconnect";
			this.btnDisconnect.Size = new System.Drawing.Size(104, 32);
			this.btnDisconnect.TabIndex = 16;
			this.btnDisconnect.Text = "Disconnect";
			this.btnDisconnect.Click += new System.EventHandler(this.button1_Click_2);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 377);
			this.Controls.Add(this.btnDisconnect);
			this.Controls.Add(this.lblLoopDelay);
			this.Controls.Add(this.inputLoopDelay);
			this.Controls.Add(this.inputLoopRead);
			this.Controls.Add(this.lblMaxTagCount);
			this.Controls.Add(this.inputMaxTagCount);
			this.Controls.Add(this.inputQnum);
			this.Controls.Add(this.lblQnum);
			this.Controls.Add(this.quit);
			this.Controls.Add(this.connect);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.listBox1);
			this.Controls.Add(this.clear);
			this.Controls.Add(this.networkstatus);
			this.Controls.Add(this.readtag);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "RFID Console";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			rdr1.InvUpdateGap = 350;
			rdr1.InvTimerEnabled = true;
			rdr1.Gen2InventoryEnabled = false;
			inputQnum.Text = Gen2InventorySettings.startingQ.ToString();
			inputMaxTagCount.Text = Gen2InventorySettings.maxTagCount.ToString();
			inputLoopDelay.Text = rdr1.InvUpdateGap.ToString();
			rdr1.TagAdded += new TagEventHandler(rdr1_TagAdded);
			rdr1.TagRemoved += new TagEventHandler(rdr1_TagRemoved);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			listBox1.Items.Clear();
			listBox1.Items.Add("Tag Results:");
			listBox1.Items.Add("****************************");

			if (connected) 
			{
				if (inputLoopRead.Checked)
				{
					rdr1.Gen2Inventory.persistTime = new TimeSpan(0, 0, 2);
					rdr1.Gen2InventoryEnabled = true;
					listBox1.Items.Add("Tags found:");
				}
				else 
				{
					readerInv = rdr1.Gen2Inventory;
					int tagsRead = readerInv.CountClass[2];
					listBox1.Items.Add("Tags found: " + tagsRead.ToString());
					for (int i = 0; i < tagsRead; i++)
						listBox1.Items.Add(readerInv.ToArray()[i].ToString());
				}
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			listBox1.Items.Clear();
			listBox1.Items.Add("Network Status:");
			listBox1.Items.Add("****************************");

			if (connected)
			{
				ArrayList nodesConnected = rdr1.DARNnetReport();
				int numNodes = nodesConnected.Count;
				listBox1.Items.Add("Nodes connected: " + numNodes);
				listBox1.Items.Add("Found:");
				for (int i = 0; i < numNodes; i++)
					listBox1.Items.Add("\t" + nodesConnected[i].ToString());
			}
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			if (textBox1.Text.Length == 4)
				connect.Enabled = true;
			else
				connect.Enabled = false;
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			cleanupQuit();
		}

		private void listBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			listBox1.Items.Clear();
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label2_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			string comPort = textBox1.Text;
			connected = rdr1.Connect(comPort, "57600");
	
			if (connected) 
			{
				readtag.Enabled = true;
				networkstatus.Enabled = true;
				lblQnum.Visible = true;
				inputQnum.Visible = true;
				lblMaxTagCount.Visible = true;
				inputMaxTagCount.Visible = true;
				btnDisconnect.Enabled = true;
			}
		}

		private void button1_Click_1(object sender, System.EventArgs e)
		{
			cleanupQuit();
		}

		private void inputQnum_TextChanged(object sender, System.EventArgs e)
		{
			if (inputQnum.Text == "")
				inputQnum.Text = "0";
			if (Convert.ToUInt16(inputQnum.Text) > 255)
				inputQnum.Text = "255";

			Gen2InventorySettings.startingQ = (byte)(0xFF & Convert.ToUInt16(inputQnum.Text));
			rdr1.Gen2InventorySettings = Gen2InventorySettings;
		}

		private void inputMaxTagCount_TextChanged(object sender, System.EventArgs e)
		{		
			if (inputMaxTagCount.Text == "")
				inputMaxTagCount.Text = "0";
			if (Convert.ToUInt16(inputMaxTagCount.Text) > 255)
				inputMaxTagCount.Text = "255";

			Gen2InventorySettings.startingQ = (byte)(0xFF & Convert.ToUInt16(inputMaxTagCount.Text));
			rdr1.Gen2InventorySettings = Gen2InventorySettings;
		}

		private void cleanupQuit() 
		{
			rdr1.Dispose();
			Form1.ActiveForm.Close();
		}

		private void rdr1_TagAdded(RFIDTag Tag)
		{
			listBox1.Items.Add(Tag.ToString());
		}

		private void rdr1_TagRemoved(RFIDTag Tag)
		{
			listBox1.Items.Remove(Tag.ToString());
		}

		private void inputLoopRead_CheckedChanged(object sender, System.EventArgs e)
		{
			if (!inputLoopRead.Checked) 
			{
				rdr1.Gen2InventoryEnabled = false;
				listBox1.Items.Clear();
			}
		}

		private void inputLoopDelay_TextChanged(object sender, System.EventArgs e)
		{
			if (inputMaxTagCount.Text == "")
				inputMaxTagCount.Text = rdr1.InvUpdateGap.ToString();
			if (Convert.ToUInt16(inputMaxTagCount.Text) > 59999)
				inputMaxTagCount.Text = "59999";

			rdr1.InvUpdateGap = (Convert.ToUInt16(inputMaxTagCount.Text));
		}

		private void button1_Click_2(object sender, System.EventArgs e)
		{
			if (connected)
			{
				rdr1.Disconnect();
				connected = false;
			}
			readtag.Enabled = false;
			networkstatus.Enabled = false;
			lblQnum.Visible = false;
			inputQnum.Visible = false;
			lblMaxTagCount.Visible = false;
			inputMaxTagCount.Visible = false;
			btnDisconnect.Enabled = false;
		}
	}
}
