/* ____________________________________________________________________________
#  Copyright (c) 2004
# 	Helicomm Inc.  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are prohibited without the written consents of Helicomm, Inc.
#
#  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
* _____________________________________________________________________________
*
* File:                Publib.h
*_______________________________________________________________________________*/
/*
* CVS Revision History:
*   
*    $Id: Publib.h,v 1.1 2005/03/30 18:19:38 cvs Exp $
* 
*/


/*! \file       include/publib.h
  *  @ingroup group_mcu
  * \brief   Header file for public library
  *
  */
  

#ifndef PublibH
#define PublibH

#define TRUE     1
#define FALSE    0

#ifndef tag_BOOL
  #define tag_BOOL
  typedef unsigned char       BOOL;
#endif

#ifndef tag_LONG
  #define tag_LONG
  typedef signed   long  LONG;
#endif

#ifndef tag_INT
  #define tag_INT
  typedef signed   short INT;
#endif

#ifndef tag_CHAR
  #define tag_CHAR
  typedef signed   char CHAR;
#endif

#ifndef tag_BYTE
  #define tag_BYTE
  typedef unsigned char BYTE;
#endif

#ifndef tag_WORD
  #define tag_WORD
  typedef unsigned short WORD;
#endif

#ifndef tag_DWORD
  #define tag_DWORD
  typedef unsigned long DWORD;
#endif

#ifndef tag_VOID
  #define tag_VOID
  typedef void  VOID;
#endif

void          bytehexcat(unsigned char xdata *str, unsigned char bydata);

void          intcat( BYTE xdata *str, WORD  nt);
void          bytecat(BYTE xdata *str, BYTE  nt);

void          Cstrcpy(BYTE xdata * lpDest, BYTE code  * lpSrc);
void          Xstrcpy(BYTE xdata * lpDest, BYTE xdata * lpSrc);

void          Cstrcat(BYTE xdata * lpDest, BYTE code  * lpSrc);
void          Xstrcat(BYTE xdata * lpDest, BYTE xdata * lpSrc);

INT           Xstrlen(BYTE xdata * lpStr);
INT           Cstrlen(BYTE code  * lpStr);

void          Xmemswap(void xdata * lpSrc, void xdata * lpDest, unsigned char nLen);

void          Dmemset(void data * lpDest, BYTE Value, unsigned char nLen);

//#pragma SAVE
//#pragma REGPARMS

extern void   Xmemset(void xdata * lpDest, unsigned char Value, unsigned char nLen);

extern void   Xmemcpy(void xdata *lpDest, void xdata *lpSrc, unsigned char nLen);
extern void   Cmemcpy(void xdata *lpDest, void code  *lpSrc, unsigned char nLen);

extern BYTE   Xmemcmp(void xdata *lpDest, void xdata *lpSrc, unsigned char nLen);
extern BYTE   Cmemcmp(void xdata *lpDest, void code  *lpSrc, unsigned char nLen);
//#pragma RESTORE

extern unsigned char code  CharStr[16];


#endif




