#ifndef PORTDEFS_H
#define PORTDEFS_H

#include "../include/hal/c8051F120.h"
#include "../include/hal/hal_f121db.h"

#define LED6_ON()         (P2 &= 0x7F)             // LED on
#define LED6_OFF()        (P2 |= 0x80)             // LED off

#define LED7_ON()         (P2 &= 0xBF)             // LED on
#define LED7_OFF()        (P2 |= 0x40)             // LED off

#define LED8_ON()         (P2 &= 0xDF)             // LED on
#define LED8_OFF()        (P2 |= 0x20)             // LED off

#define LED9_ON()         (P2 &= 0xEF)             // LED on
#define LED9_OFF()        (P2 |= 0x10)             // LED off

#define LED10_ON()        (P2 &= 0xF7)             // LED on
#define LED10_OFF()       (P2 |= 0x08)             // LED off

#define LED11_ON()        (P2 &= 0xFB)             // LED on
#define LED11_OFF()       (P2 |= 0x04)             // LED off

#define LED12_ON()        (P2 &= 0xFD)             // LED on
#define LED12_OFF()       (P2 |= 0x02)             // LED off

#define LED13_ON()        (P2 &= 0xFE)             // LED on
#define LED13_OFF()       (P2 |= 0x01)             // LED off

#define ALL_LEDS_OFF()    (P2 = 0xFF)              // Turn off all Leds

#define BUTTON_SW3  BUTTON0
#define BUTTON_SW4  BUTTON1
#define BUTTON_SW5  BUTTON2
#define BUTTON_SW6  BUTTON3

#endif